#include <stdlib.h>
#include <util/delay.h>

#include "graphics.h"
#include "hal.h"

static void hardware_init(void)
{
    /* Port B = Input, except LCD RST */
    PORTB= 0xFF;
    DDRB=  _BV(RST);

    /* */
    PORTC= ~(_BV(EN));
    DDRC=  (_BV(RS) | _BV(RW) | _BV(EN) | _BV(PSB));

    /* data bus pins are outputs */
    /* pullups enabled on all pins */
    PORTD= 0xFF;
    DDRD=  0xFF;

    /* disable Analog Comparator */
    ACSR = (_BV(ACD));
}


int main (void)
{
    hardware_init();

    st7920_init();
    st7920_set_mode(invert);
    st7920_clear();

    for (uint8_t y=0; y<ST7920_HEIGHT; y+=2) {
        gfx_hline(0, y, ST7920_WIDTH-1);
        _delay_ms(50);
    }
    _delay_ms(200);

    for (uint8_t x=0; x<ST7920_WIDTH; x+=2) {
        gfx_vline(x, 0, ST7920_HEIGHT-1);
        _delay_ms(50);
    }
    _delay_ms(200);

    st7920_swap();
    _delay_ms(500);
    st7920_clear();

    for (uint8_t z=0; z<ST7920_HEIGHT/2; z++) {
        gfx_fillrect(z, z, ST7920_WIDTH-1-z, ST7920_HEIGHT-1-z);
        _delay_ms(50);
    }

    while (1) {
        _delay_ms(1000);
        st7920_swap();
    }
}

